package models

import "github.com/beego/beego/v2/client/orm"

func GetCountCompanyDetailByIdGroupTrip(companyId int) (count int, err error) {
	o := orm.NewOrm()
	sql := ` SELECT
	COUNT( 1 ) AS count 
FROM
	company AS a
	INNER JOIN company_product AS b ON a.company_id = b.company_id
	INNER JOIN company_report_permission AS p ON p.company_id = a.company_id
	INNER JOIN chart_permission AS cp ON cp.chart_permission_id = p.chart_permission_id
	LEFT JOIN admin AS c ON b.seller_id = c.admin_id 
WHERE
	a.company_id = ? 
	AND b.product_id = 2 
	AND b.status = '正式' 
	AND p.is_upgrade =  1
	OR (
		a.company_id = ? 
	AND b.product_id = 2 
	AND b.status = '永续') `
	err = o.Raw(sql, companyId, companyId).QueryRow(&count)
	return
}

func GetCompanyDetailByIdGroupTrip(companyId int) (item *CompanyDetail, err error) {
	o := orm.NewOrm()
	sql := ` SELECT a.company_id,a.company_name,b.status,b.seller_id,b.seller_name,c.mobile ,b.is_suspend
            FROM company AS a
			INNER JOIN company_product AS b ON a.company_id=b.company_id
			INNER JOIN company_report_permission AS p ON p.company_id = a.company_id
			INNER JOIN chart_permission AS cp ON cp.chart_permission_id = p.chart_permission_id
			LEFT JOIN admin AS c ON b.seller_id=c.admin_id
			WHERE a.company_id=? AND b.product_id = 2  
			ORDER BY b.product_id DESC  LIMIT 0,1  `
	err = o.Raw(sql, companyId).QueryRow(&item)
	return
}

func GetCompanyPermissionByUserTrip(companyId int) (permission string, err error) {
	o := orm.NewOrm()
	sql := ` SELECT
			GROUP_CONCAT( DISTINCT b.remark ORDER BY b.sort ASC SEPARATOR ',' ) AS permission 
		FROM
			company_report_permission AS a
			INNER JOIN chart_permission AS b ON a.chart_permission_id = b.chart_permission_id
			INNER JOIN company_product AS c ON a.company_id = c.company_id 
			AND a.product_id = c.product_id 
		WHERE
			a.company_id = ? 
			AND c.is_suspend = 0 
			AND b.cygx_auth = 1 
			AND a.is_upgrade = 1 
			AND c.STATUS IN ( '正式' ) 
			OR ( a.company_id = ? AND c.is_suspend = 0 AND b.cygx_auth = 1 AND c.STATUS IN ( '永续' ) ) 
			OR ( a.company_id = ? AND c.is_suspend = 0 AND b.cygx_auth = 1 AND b.chart_permission_name = '策略' AND c.STATUS IN ( '正式' ) )`
	err = o.Raw(sql, companyId, companyId, companyId).QueryRow(&permission)
	return
}

//获取正式权限
func GetCompanyPermissionByUserZhengShiTrip(companyId int) (permission string, err error) {
	sql := ` SELECT GROUP_CONCAT(DISTINCT b.remark  ORDER BY b.sort ASC  SEPARATOR ',') AS permission
			FROM company_report_permission AS a
			INNER JOIN chart_permission AS b ON a.chart_permission_id=b.chart_permission_id
			INNER JOIN company_product AS c ON a.company_id=c.company_id AND a.product_id=c.product_id
			WHERE  a.company_id=?
			AND c.is_suspend=0
            AND b.cygx_auth=1
			AND a.is_upgrade = 1 
			AND c.status IN('正式')  `
	o := orm.NewOrm()
	err = o.Raw(sql, companyId).QueryRow(&permission)
	return
}
